diff --git a/tests/Feature/Repositories/Permission/EloquentPermissionTest.php b/tests/Feature/Repositories/Permission/EloquentPermissionTest.php
new file mode 100644
index 0000000..0aa2326
--- /dev/null
+++ b/tests/Feature/Repositories/Permission/EloquentPermissionTest.php
@@ -0,0 +1,86 @@
+<?php
+
+namespace Tests\Feature\Repositories\Permission;
+
+use Cache;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Events\Permission\Created;
+use Portal\Permission;
+use Portal\Repositories\Permission\EloquentPermission;
+
+class EloquentPermissionTest extends FunctionalTestCase
+{
+    /**
+     * @var EloquentPermission
+     */
+    protected $repo;
+
+    protected $seed = false;
+
+    public function setUp()
+    {
+        parent::setUp();
+        $this->repo = app(EloquentPermission::class);
+    }
+
+    public function test_all()
+    {
+        $permissions = factory(Permission::class)->times(4)->create();
+
+        $this->assertEquals($permissions->toArray(), $this->repo->all()->toArray());
+    }
+
+    public function test_create()
+    {
+        $this->expectsEvents(Created::class);
+
+        $data = $this->getPermissionStubData();
+
+        $perm = $this->repo->create($data);
+
+        $this->seeInDatabase('permissions', $data + ['id' => $perm->id]);
+    }
+
+    public function test_update()
+    {
+        $this->expectsEvents(\Portal\Events\Permission\Updated::class);
+
+        Cache::put('foo', 'bar');
+
+        $data = $this->getPermissionStubData();
+
+        $perm = factory(Permission::class)->create();
+
+        $this->repo->update($perm->id, $data);
+
+        $this->seeInDatabase('permissions', $data + ['id' => $perm->id])
+            ->assertNull(Cache::get('foo'));
+    }
+
+    public function test_delete()
+    {
+        $this->expectsEvents(\Portal\Events\Permission\Deleted::class);
+
+        Cache::put('foo', 'bar');
+
+        $perm = factory(Permission::class)->create();
+
+        $this->repo->delete($perm->id);
+
+        $this->notSeeInDatabase('permissions', ['id' => $perm->id])
+            ->assertNull(Cache::get('foo'));
+    }
+
+    /**
+     * @return array
+     */
+    private function getPermissionStubData()
+    {
+        return [
+            'name'         => str_random(5),
+            'display_name' => str_random(5),
+            'description'  => 'foo',
+            'removable'    => true
+        ];
+    }
+}
diff --git a/tests/Feature/Repositories/Role/EloquentRoleTest.php b/tests/Feature/Repositories/Role/EloquentRoleTest.php
new file mode 100644
index 0000000..26add27
--- /dev/null
+++ b/tests/Feature/Repositories/Role/EloquentRoleTest.php
@@ -0,0 +1,106 @@
+<?php
+
+namespace Tests\Feature\Repositories\Role;
+
+use Mockery as m;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Events\Role\Created;
+use Portal\Repositories\Role\EloquentRole;
+use Portal\Role;
+use Portal\User;
+
+class EloquentRoleTest extends FunctionalTestCase
+{
+    /**
+     * @var EloquentRole
+     */
+    protected $repo;
+
+    protected $seed = false;
+
+    public function setUp()
+    {
+        parent::setUp();
+        $this->repo = app(EloquentRole::class);
+    }
+
+    public function test_all()
+    {
+        $roles = factory(Role::class)->times(4)->create();
+
+        $this->assertEquals(
+            $roles->toArray(),
+            $this->repo->all()->toArray()
+        );
+    }
+
+    public function test_getAllWithUsersCount()
+    {
+        $roles = factory(Role::class)->times(4)->create();
+        $users = factory(User::class)->times(3)->create();
+
+        $this->setRoleForUser($users[0], $roles[0]->name);
+        $this->setRoleForUser($users[1], $roles[0]->name);
+        $this->setRoleForUser($users[2], $roles[1]->name);
+
+        $roles[0]->users_count = 2;
+        $roles[1]->users_count = 1;
+        $roles[2]->users_count = 0;
+        $roles[3]->users_count = 0;
+
+        $this->assertEquals($roles->toArray(), $this->repo->getAllWithUsersCount()->toArray());
+    }
+
+    public function test_create()
+    {
+        $this->expectsEvents(Created::class);
+
+        $data = ['name' => 'foo', 'display_name' => 'Foo'];
+        $role = $this->repo->create($data);
+
+        $this->seeInDatabase('roles', $data + ['id' => $role->id]);
+    }
+
+    public function test_update()
+    {
+        $this->expectsEvents(\Portal\Events\Role\Updated::class);
+
+        $role = factory(Role::class)->create();
+
+        $data = ['name' => 'foo', 'display_name' => 'Foo'];
+
+        $this->repo->update($role->id, $data);
+
+        $this->seeInDatabase('roles', $data + ['id' => $role->id]);
+    }
+
+    public function test_delete()
+    {
+        $this->expectsEvents(\Portal\Events\Role\Deleted::class);
+
+        $role = factory(Role::class)->create();
+
+        $this->repo->delete($role->id);
+
+        $this->dontSeeInDatabase('roles', ['id' => $role->id]);
+    }
+
+    public function test_updatePermissions()
+    {
+        $role = factory(Role::class)->create();
+        $permissions = factory(\Portal\Permission::class)->times(2)->create();
+
+        $this->repo->updatePermissions($role->id, $permissions->pluck('id')->toArray());
+
+        $this->seeInDatabase('permission_role', ['role_id' => $role->id, 'permission_id' => $permissions[0]->id]);
+        $this->seeInDatabase('permission_role', ['role_id' => $role->id, 'permission_id' => $permissions[1]->id]);
+    }
+
+    public function test_lists()
+    {
+        $roles = factory(Role::class)->times(4)->create();
+        $roles = $roles->pluck('name', 'id');
+
+        $this->assertEquals($roles->toArray(), $this->repo->lists()->toArray());
+    }
+}
diff --git a/tests/Feature/Repositories/Session/DbSessionTest.php b/tests/Feature/Repositories/Session/DbSessionTest.php
new file mode 100644
index 0000000..694b222
--- /dev/null
+++ b/tests/Feature/Repositories/Session/DbSessionTest.php
@@ -0,0 +1,109 @@
+<?php
+
+namespace Tests\Feature\Repositories\Session;
+
+use Carbon\Carbon;
+use DB;
+use Mockery as m;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Repositories\Session\DbSession;
+use Portal\User;
+
+class DbSessionTest extends FunctionalTestCase
+{
+    /**
+     * @var DbSession
+     */
+    protected $repo;
+
+    protected $seed = false;
+
+    public function setUp()
+    {
+        parent::setUp();
+        $this->repo = app(DbSession::class);
+    }
+
+    public function test_getUserSessions()
+    {
+        $user = factory(User::class)->create();
+
+        Carbon::setTestNow(Carbon::now());
+
+        $data1 = $this->getSessionStubData($user);
+        $data2 = $this->getSessionStubData($user);
+
+        DB::table('sessions')->insert($data1);
+        DB::table('sessions')->insert($data2);
+
+        $expected = collect([
+            (object) array_except($data1, ['payload', 'user_id']),
+            (object) array_except($data2, ['payload', 'user_id']),
+        ]);
+        $expected = $expected->sortBy('id')->keyBy('id')->toArray();
+
+        $actual = collect($this->repo->getUserSessions($user->id))
+            ->sortBy('id')
+            ->keyBy('id')
+            ->toArray();
+
+
+        $this->assertEquals($expected, $actual);
+    }
+
+    public function test_if_get_user_sessions_will_return_active_sessions_only()
+    {
+        $user = factory(User::class)->create();
+
+        Carbon::setTestNow(Carbon::now());
+
+        $data1 = $this->getSessionStubData($user);
+        $data2 = $this->getSessionStubData($user);
+        $data2['last_activity'] = Carbon::now()->subMinutes(config('session.lifetime') + 1)->timestamp;
+
+        DB::table('sessions')->insert($data1);
+        DB::table('sessions')->insert($data2);
+
+        $expected = collect([
+            (object) array_except($data1, ['payload', 'user_id']),
+        ]);
+        $expected = $expected->sortBy('id')->keyBy('id')->toArray();
+
+        $actual = collect($this->repo->getUserSessions($user->id))
+            ->sortBy('id')
+            ->keyBy('id')
+            ->toArray();
+
+
+        $this->assertEquals($expected, $actual);
+    }
+
+    public function test_invalidateUserSession()
+    {
+        $user = factory(User::class)->create([
+            'remember_token' => str_random(60)
+        ]);
+
+        $data = $this->getSessionStubData($user);
+        DB::table('sessions')->insert($data);
+
+        $this->repo->invalidateUserSession($user->id, $data['id']);
+
+        $this->dontSeeInDatabase('sessions', $data)
+            ->seeInDatabase('users', ['remember_token' => null]);
+    }
+
+    private function getSessionStubData($user)
+    {
+        $faker = app(\Faker\Generator::class);
+
+        return [
+            'id' => str_random(),
+            'user_id' => $user->id,
+            'ip_address' => $faker->ipv4,
+            'user_agent' => $faker->userAgent,
+            'payload' => 'foo',
+            'last_activity' => Carbon::now()->timestamp
+        ];
+    }
+}
diff --git a/tests/Feature/Repositories/User/EloquentUserTest.php b/tests/Feature/Repositories/User/EloquentUserTest.php
new file mode 100644
index 0000000..9657392
--- /dev/null
+++ b/tests/Feature/Repositories/User/EloquentUserTest.php
@@ -0,0 +1,379 @@
+<?php
+
+namespace Tests\Feature\Repositories\User;
+
+use DB;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Repositories\User\EloquentUser;
+use Portal\Role;
+use Portal\Support\Enum\UserStatus;
+use Portal\User;
+use Carbon\Carbon;
+use Mockery as m;
+
+class EloquentUserTest extends FunctionalTestCase
+{
+    /**
+     * @var EloquentUser
+     */
+    protected $repo;
+
+    public function setUp()
+    {
+        parent::setUp();
+        $this->repo = app(EloquentUser::class);
+    }
+
+    public function test_find()
+    {
+        $user = factory(User::class)->create();
+
+        $this->assertArraySubset(
+            $user->toArray(),
+            $this->repo->find($user->id)->toArray()
+        );
+
+        $this->assertNull($this->repo->find(123));
+    }
+
+    public function test_findByEmail()
+    {
+        $user = factory(User::class)->create();
+
+        $this->assertArraySubset(
+            $user->toArray(),
+            $this->repo->findByEmail($user->email)->toArray()
+        );
+
+        $this->assertNull($this->repo->findByEmail('foo@bar.com'));
+    }
+
+    public function test_findBySocialId()
+    {
+        $user = factory(User::class)->create();
+
+        DB::table('social_logins')->insert([
+            'user_id' => $user->id,
+            'provider' => 'foo',
+            'provider_id' => '123',
+            'avatar' => '',
+            'created_at' => Carbon::now()
+        ]);
+
+        $this->assertArraySubset(
+            $user->toArray(),
+            $this->repo->findBySocialId('foo', '123')->toArray()
+        );
+
+        $this->assertNull($this->repo->findBySocialId('bar', '111'));
+    }
+
+    public function test_create()
+    {
+        $data = factory(User::class)->make()->toArray();
+
+        $this->repo->create($data + ['password' => 'foo']);
+
+        $this->seeInDatabase('users', $data);
+    }
+
+    public function test_create_without_country()
+    {
+        $data1 = factory(User::class)->make(['country_id' => "0"])->toArray();
+        $data2 = factory(User::class)->make(['country_id' => 0])->toArray();
+
+        $this->repo->create($data1 + ['password' => 'foo']);
+        $this->repo->create($data2 + ['password' => 'bar']);
+
+        $expected1 = $data1;
+        $expected1['country_id'] = null;
+
+        $expected2 = $data2;
+        $expected2['country_id'] = null;
+
+        $this->seeInDatabase('users', $expected1);
+        $this->seeInDatabase('users', $expected2);
+    }
+
+    public function test_associateSocialAccountForUser()
+    {
+        $user = factory(User::class)->create();
+
+        Carbon::setTestNow(Carbon::now());
+
+        $socialUser = new \Laravel\Socialite\One\User();
+        $socialUser->map(['id' => '123', 'avatar' => 'foo']);
+
+        $this->repo->associateSocialAccountForUser($user->id, 'facebook', $socialUser);
+
+        $this->seeInDatabase('social_logins', [
+            'user_id' => $user->id,
+            'provider' => 'facebook',
+            'provider_id' => '123',
+            'avatar' => 'foo',
+            'created_at' => Carbon::now()
+        ]);
+
+        Carbon::setTestNow(null);
+    }
+
+    public function test_paginate()
+    {
+        $users = factory(User::class)->times(5)->create();
+
+        $result = $this->repo->paginate(2)->toArray();
+
+        $this->assertEquals(2, count($result['data']));
+        $this->assertEquals(5, $result['total']);
+        $this->assertArraySubset($users[0]->toArray(), $result['data'][0]);
+        $this->assertArraySubset($users[1]->toArray(), $result['data'][1]);
+    }
+
+    public function test_paginate_with_status()
+    {
+        factory(User::class)->times(3)->create();
+        factory(User::class)->create(['status' => UserStatus::BANNED]);
+
+        $active = $this->repo->paginate(2, null, UserStatus::ACTIVE)->toArray();
+        $banned = $this->repo->paginate(2, null, UserStatus::BANNED)->toArray();
+
+        $this->assertEquals(2, count($active['data']));
+        $this->assertEquals(3, $active['total']);
+
+        $this->assertEquals(1, count($banned['data']));
+        $this->assertEquals(1, $banned['total']);
+    }
+
+    public function test_paginate_with_search()
+    {
+        factory(User::class)->create(['first_name' => 'John', 'last_name' => 'Doe', 'username' => 'jdoe', 'email' => 'joe@test.com']);
+        factory(User::class)->create(['first_name' => 'Jane', 'last_name' => 'Doe', 'username' => 'janedoe', 'email' => 'jane@doe.com']);
+        factory(User::class)->create(['first_name' => 'Milos', 'last_name' => 'Stojanovic', 'email' => 'test@test.com']);
+
+        $this->assertEquals(2, $this->repo->paginate(25, 'doe')->total());
+        $this->assertEquals(1, $this->repo->paginate(25, 'Milos')->total());
+        $this->assertEquals(2, $this->repo->paginate(25, 'test')->total());
+        $this->assertEquals(2, $this->repo->paginate(25, 'an')->total());
+    }
+
+    public function test_update()
+    {
+        $user = factory(User::class)->create();
+
+        $data = [
+            'first_name' => 'John',
+            'last_name' => 'Doe',
+            'username' => 'foo',
+            'email' => 'test@test.com'
+        ];
+
+        $this->repo->update($user->id, $data);
+
+        $this->seeInDatabase('users', $data + ['id' => $user->id]);
+    }
+
+    public function test_update_without_country()
+    {
+        $user1 = factory(User::class)->create();
+        $user2 = factory(User::class)->create();
+
+        $data = [
+            'first_name' => 'John',
+            'last_name' => 'Doe',
+            'username' => 'foo',
+            'email' => 'test@test.com',
+            'country_id' => "0"
+        ];
+
+        $data2 = [
+            'first_name' => 'Jane',
+            'last_name' => 'Doe',
+            'username' => 'bar',
+            'email' => 'test2@test.com',
+            'country_id' => 0
+        ];
+
+        $this->repo->update($user1->id, $data);
+        $this->repo->update($user2->id, $data2);
+
+        $data['country_id'] = null;
+        $data2['country_id'] = null;
+
+        $this->seeInDatabase('users', $data + ['id' => $user1->id]);
+        $this->seeInDatabase('users', $data2 + ['id' => $user2->id]);
+    }
+
+    public function test_updateSocialNetworks()
+    {
+        $user = factory(User::class)->create();
+
+        $data = [
+            'facebook' => 'foo',
+            'twitter' => 'bar',
+            'dribbble' => 'bazz',
+            'skype' => 'skyyyype',
+            'linked_in' => 'li',
+            'google_plus' => 'g+'
+        ];
+
+        $this->repo->updateSocialNetworks($user->id, $data);
+
+        $this->seeInDatabase('user_social_networks', $data + ['user_id' => $user->id]);
+    }
+
+    public function test_delete()
+    {
+        $user = factory(User::class)->create();
+
+        $this->repo->delete($user->id);
+
+        $this->notSeeInDatabase('users', ['id' => $user->id]);
+    }
+
+    public function test_count()
+    {
+        factory(User::class)->times(7)->create();
+
+        $this->assertEquals(7, $this->repo->count());
+    }
+
+    public function test_newUsersCount()
+    {
+        Carbon::setTestNow(Carbon::now()->subMonth());
+        factory(User::class)->times(3)->create();
+
+        Carbon::setTestNow(null);
+        factory(User::class)->times(5)->create();
+
+        $this->assertEquals(5, $this->repo->newUsersCount());
+    }
+
+    public function test_countByStatus()
+    {
+        factory(User::class)->times(3)->create();
+        factory(User::class)->create(['status' => UserStatus::BANNED]);
+        factory(User::class)->times(2)->create(['status' => UserStatus::UNCONFIRMED]);
+
+        $this->assertEquals(3, $this->repo->countByStatus(UserStatus::ACTIVE));
+        $this->assertEquals(1, $this->repo->countByStatus(UserStatus::BANNED));
+        $this->assertEquals(2, $this->repo->countByStatus(UserStatus::UNCONFIRMED));
+    }
+
+    public function test_latest()
+    {
+        Carbon::setTestNow(Carbon::now()->subDay());
+        $user1 = factory(User::class)->create();
+
+        Carbon::setTestNow(null);
+        $users = factory(User::class)->times(3)->create();
+
+        $latestTwo = $this->repo->latest(2);
+        $latestFour = $this->repo->latest(4);
+
+        $this->assertEquals(2, count($latestTwo));
+        $this->assertEquals(4, count($latestFour));
+
+        $this->assertArraySubset($users[0]->toArray(), $latestTwo[0]->toArray());
+        $this->assertArraySubset($users[1]->toArray(), $latestTwo[1]->toArray());
+        $this->assertArraySubset($user1->toArray(), $latestFour[3]->toArray());
+    }
+
+    public function test_countOfNewUsersPerMonth()
+    {
+        Carbon::setTestNow(Carbon::now()->startOfYear());
+        factory(User::class)->times(2)->create();
+
+        Carbon::setTestNow(Carbon::now()->startOfYear()->addMonths(2));
+        factory(User::class)->times(4)->create();
+
+        Carbon::setTestNow(Carbon::now()->startOfYear()->addMonths(6));
+        factory(User::class)->times(2)->create();
+
+        Carbon::setTestNow(Carbon::now()->startOfYear()->addMonths(7));
+        factory(User::class)->times(1)->create();
+
+        Carbon::setTestNow(Carbon::now()->startOfYear()->addMonths(10));
+        factory(User::class)->times(4)->create();
+
+        Carbon::setTestNow(null);
+
+        $expected = [
+            'January' => 2,
+            'February' => 0,
+            'March' => 4,
+            'April' => 0,
+            'May' => 0,
+            'June' => 0,
+            'July' => 2,
+            'August' => 1,
+            'September' => 0,
+            'October' => 0,
+            'November' => 4,
+            'December' => 0
+        ];
+
+        $usersPerMonth = $this->repo->countOfNewUsersPerMonth(
+            Carbon::now()->startOfYear(),
+            Carbon::now()->endOfYear()
+        );
+
+        $this->assertEquals($expected, $usersPerMonth);
+    }
+
+    public function test_getUsersWithRole()
+    {
+        $admins = factory(User::class)->times(2)->create();
+        $role = Role::where('name', 'Admin')->first();
+        $role->users()->attach($admins->pluck('id')->toArray());
+
+        $user = factory(User::class)->create();
+        $role = Role::where('name', 'User')->first();
+        $role->users()->attach($user->id);
+
+        $result = $this->repo->getUsersWithRole('Admin');
+        $this->assertEquals(2, $result->count());
+        $this->assertArraySubset($admins[0]->toArray(), $result[0]->toArray());
+        $this->assertArraySubset($admins[1]->toArray(), $result[1]->toArray());
+
+        $result = $this->repo->getUsersWithRole('User');
+        $this->assertEquals(1, $result->count());
+        $this->assertArraySubset($user->toArray(), $result[0]->toArray());
+    }
+
+    public function test_setRole()
+    {
+        $user = factory(User::class)->create();
+        $role = Role::where('name', 'Admin')->first();
+
+        $this->repo->setRole($user->id, $role->id);
+
+        $this->seeInDatabase('role_user', [
+           'role_id' => $role->id,
+            'user_id' => $user->id
+        ]);
+    }
+
+    public function test_switchRolesForUsers()
+    {
+        $role = Role::where('name', 'User')->first();
+        $roleAdmin = Role::where('name', 'Admin')->first();
+
+        $user1 = factory(User::class)->create();
+        $user2 = factory(User::class)->create();
+
+        $this->setRoleForUser($user1, 'User');
+        $this->setRoleForUser($user2, 'User');
+
+        $this->repo->switchRolesForUsers($role->id, $roleAdmin->id);
+
+        $this->seeInDatabase('role_user', [
+            'role_id' => $roleAdmin->id,
+            'user_id' => $user1->id
+        ]);
+
+        $this->seeInDatabase('role_user', [
+            'role_id' => $roleAdmin->id,
+            'user_id' => $user2->id
+        ]);
+    }
+}
diff --git a/tests/MailTrap.php b/tests/MailTrap.php
index dc08189..d30d4e9 100644
--- a/tests/MailTrap.php
+++ b/tests/MailTrap.php
@@ -1,5 +1,9 @@
 <?php
 
+namespace Tests;
+
+use Config;
+use Exception;
 use GuzzleHttp\Client;
 
 trait MailTrap
diff --git a/tests/TestCase.php b/tests/TestCase.php
index 4819724..6e13a05 100644
--- a/tests/TestCase.php
+++ b/tests/TestCase.php
@@ -1,6 +1,8 @@
 <?php
 
-class TestCase extends Illuminate\Foundation\Testing\TestCase
+namespace Tests;
+
+class TestCase extends \Laravel\BrowserKitTesting\TestCase
 {
     protected $seed = true;
 
@@ -18,9 +20,11 @@ class TestCase extends Illuminate\Foundation\Testing\TestCase
      */
     public function createApplication()
     {
+        ini_set('memory_limit', '2048M');
+
         $app = require __DIR__.'/../bootstrap/app.php';
 
-        $app->make(Illuminate\Contracts\Console\Kernel::class)->bootstrap();
+        $app->make(\Illuminate\Contracts\Console\Kernel::class)->bootstrap();
 
         return $app;
     }
@@ -48,4 +52,3 @@ class TestCase extends Illuminate\Foundation\Testing\TestCase
         return \DB::connection() instanceof \Illuminate\Database\SQLiteConnection;
     }
 }
-
diff --git a/tests/unit/Presenters/UserPresenterTest.php b/tests/unit/Presenters/UserPresenterTest.php
index 4b8c53f..c2089c2 100644
--- a/tests/unit/Presenters/UserPresenterTest.php
+++ b/tests/unit/Presenters/UserPresenterTest.php
@@ -1,5 +1,8 @@
 <?php
 
+namespace Tests\Unit\Presenters;
+
+use Tests\TestCase;
 use Portal\Presenters\UserPresenter;
 use Portal\Support\Enum\UserStatus;
 use Carbon\Carbon;
diff --git a/webpack.mix.js b/webpack.mix.js
new file mode 100644
index 0000000..bfa7da0
--- /dev/null
+++ b/webpack.mix.js
@@ -0,0 +1,15 @@
+const { mix } = require('laravel-mix');
+
+/*
+ |--------------------------------------------------------------------------
+ | Mix Asset Management
+ |--------------------------------------------------------------------------
+ |
+ | Mix provides a clean, fluent API for defining some Webpack build steps
+ | for your Laravel application. By default, we are compiling the Sass
+ | file for the application as well as bundling up all the JS files.
+ |
+ */
+
+// mix.js('resources/assets/js/app.js', 'public/js')
+//     .sass('resources/assets/sass/app.scss', 'public/css');
\ No newline at end of file
